routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// ADMIN AREA
Route::namespace('Admin')->group( function () {
    Route::get('admin/login', 'LoginController@login_get')->name('admin.login');
//    Route::post('admin/login', 'LoginControoler@login_post')->name('admin.login');
});

Route::group(['prefix' => 'admin', 'as' => 'admin.'], function () {
    Route::get('/linkstorage', function () {
        Artisan::call('storage:link');
    });
    Route::namespace('Admin')->group( function () {
        // Dashboard
        Route::get('/', 'DashboardController@index')->name('dashboard');

        //Admin services
        Route::resource('services', 'ServiceController');
        Route::post('services/changeStatus/{id}', 'ServiceController@changeStatus')->name('services.changeStatus');

        Route::group(['prefix' => 'service', 'as' => 'service.'], function () {
            Route::resource('posts', 'ServicePostController');
            Route::post('posts/changeStatus/{id}', 'ServicePostController@changeStatus')->name('posts.changeStatus');
        });

        //Admin Projects
        Route::resource('projects', 'ProjectController');
        Route::post('projects/changeStatus/{id}', 'ProjectController@changeStatus')->name('projects.changeStatus');

        Route::group(['prefix' => 'project', 'as' => 'project.'], function () {
            Route::resource('posts', 'ProjectPostController');
            Route::post('posts/changeStatus/{id}', 'ProjectPostController@changeStatus')->name('posts.changeStatus');
        });

        Route::resources([
            'contacts' => 'ContactController',
            'banners' => 'BannerController',
        ]);

   });
});




//Route::namespace('Auth')->group(function () {
//    Route::get('cart/login', 'CartLoginController@showLoginForm')->name('cart.login');
//    Route::post('cart/login', 'CartLoginController@login')->name('cart.login');
//    Route::get('logout', 'LoginController@logout');
//});

Route::namespace('Front')->group( function () {
    Route::get('/', 'HomeController@index')->name('home');
    Route::get('/dich-vu', 'ServiceController@index')->name('services.index');
    Route::get('/dich-vu/{slug}', 'ServiceController@detail')->name('services.detail');
    Route::get('/dich-vu/{slug_service}/{slug_post}', 'ServiceController@post_detail')->name('services.post.detail');
    Route::get('/san-pham', 'OurProjectController@index')->name('project');
    Route::get('/lien-he', 'ContactController@index')->name('contact');
    Route::get('/gioi-thieu', 'AboutController@index')->name('about');
});

app/Service.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Service extends Model
{
    protected $table = "services";

    protected $fillable = [
        'name',
        'slug',
        'description',
        'img',
        'status'
    ];

    public function service_posts()
    {
        return $this->hasMany('App\ServicePost');
    }
}

app/Http/Controllers/Admin/ServiceController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Cassandra\Session;
use Illuminate\Http\Request;
use Validator;
use Illuminate\Support\Str;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\File;
use App\Service;


class ServiceController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $services = Service::latest()->paginate(15);

        return view('admin.services.list', compact('services'))
                ->with('i', (request()->input('page', 1) - 1) * 15);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.services.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $input_datas = $request->all();
        $request->validate([
            'name'         => 'required',
            'slug'         => 'required',
            'img'          => 'required|image|mimes:jpeg,png,jpg,gif,svg|max:2048',
            'description' => 'required',
        ]);
        $cover = $request->file('img');
        $extension = $cover->getClientOriginalExtension();
        $image_name = $cover->getFilename().'_'.Str::random(20);
        $image_url = 'images/services/'.$image_name.'.'.$extension;
        Storage::disk('public')->put($image_url,  File::get($cover));
//        $success = $img->move($upload_path,$image_full_name);

        unset($input_datas['img']);
        unset($input_datas['_token']);
        $input_datas = array_merge($input_datas, ['img' => $image_url]);

        Service::firstOrCreate($input_datas);

        return redirect()->route('admin.services.index')->with('message', 'Create successful');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $service = Service::find($id);
        return view('admin.services.show', compact('service'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $service = Service::find($id);
        return view('admin.services.edit', compact('service'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $input_datas = $request->all();
        $service = Service::findOrFail($id);
        $cover = $request->file('img');
        if (!empty($cover)) {
            $request->validate([
                'name'         => 'required',
                'slug'         => 'required',
                'img'          => 'image|mimes:jpeg,png,jpg,gif,svg|max:2048',
                'description' => 'required',
            ]);
            $extension = $cover->getClientOriginalExtension();
            $image_name = $cover->getFilename().'_'.Str::random(20);
            $image_url = 'images/services/'.$image_name.'.'.$extension;
            Storage::disk('public')->put($image_url,  File::get($cover));
            unset($input_datas['img']);
            $input_datas = array_merge($input_datas, ['img' => $image_url]);

        } else {
            $request->validate([
                'name'         => 'required',
                'slug'         => 'required',
                'description' => 'required',
            ]);
        }

        $service->update($input_datas);

        return redirect()->route('admin.services.index')->with('message', 'Update successful');
    }

    /**Update
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $service = Service::findOrFail($id);
        $service->delete();
        return redirect()->route('admin.services.index')->with('message', ' Data is successfully deleted');
    }

    public function changeStatus(Request $request, $id)
    {
        $service = Service::findOrFail($id);
        $status = $request->status;

        if ($service->update(['status' => $status])) {
            return response()->json([
                'status' =>true,
                'message'=>'Update status successfully.'
            ]);
        } else {
            return response()->json([
                'status' => false,
                'message'=>'Update status fail.'
            ]);
        }
    }
}

app/Http/Controllers/Front/ServiceController.php
<?php

namespace App\Http\Controllers\Front;

use App\Http\Controllers\Controller;
use App\ServicePost;
use Illuminate\Http\Request;
use App\Service;

class ServiceController extends Controller
{
    public function index()
    {
        $services = Service::where('status', 1)->latest()->paginate(6);
        return view('front.services.index', compact('services'));
    }

    public function detail($slug)
    {
        $service = Service::with(['service_posts' => function ($q) {
            $q->where('status', 1);
        }])->where('slug', $slug)->first();
        return view('front.services.detail', compact('service'));
    }

    public function post_detail($slug_service, $slug_post)
    {
        $service_post = ServicePost::with(['service'])->where('slug', $slug_post)->first();
        return view('front.services.posts.detail', compact('service_post'));
    }
}

resources/views/admin/services/posts/create.blade.php
@extends('layouts.admin.app')

@section('content')
    <!-- Main content -->
    <section class="content content-section">
        <div class="container-fluid">
            <div class="row">
                <!-- left column -->
                <div class="col-md-12">
                    <!-- general form elements -->
                    <div class="card card-warning">
                        <div class="card-header">
                            <h3 class="card-title">Add Service Posts</h3>
                        </div>
                        <!-- /.card-header -->
                        <!-- form start -->
                        <form role="form" action="{{ route('admin.service.posts.store') }}" method="post" enctype="multipart/form-data">
                            <div class="card-body">
                                @include('layouts.errors-and-messages')
                                {{ csrf_field() }}
                                <div class="form-group">
                                    <label for="inputName">Name</label>
                                    <input type="text" name="name" class="form-control" id="inputName" placeholder="Enter Name" value="{{ old('name') }}">
                                </div>
                                <div class="form-group">
                                    <label for="inputSlug">Slug</label>
                                    <input type="text" name="slug" class="form-control" id="inputSlug" placeholder="Enter Slug" value="{{ old('slug') }}">
                                </div>
                                <div class="form-group">
                                    <label>Services</label>
                                    <select class="form-control select2" name="service_id" style="width: 100%;">
                                        @foreach($services as $key => $service)
                                        <option value="{{ $service->id }}" >{{ $service->name }}</option>
                                        @endforeach
                                    </select>
                                </div>
                                <div class="form-group">
                                    <label for="exampleInputFile">Image</label>
                                    <div class="input-group">
                                        <div class="custom-file">
                                            <input type="file" name="img" class="custom-file-input" id="exampleInputFile" value="{{ old('img') }}">
                                            <label class="custom-file-label" for="exampleInputFile">Choose file</label>
                                        </div>
                                        <div class="input-group-append">
                                            <span class="input-group-text" id="">Upload</span>
                                        </div>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label>Status</label>
                                    <select class="form-control select2" name="status" style="width: 100%;">
                                        <option value="1" selected="selected">Yes</option>
                                        <option value="0">No</option>
                                    </select>
                                </div>
                                <div class="form-group">
                                    <label for="exampleDescription">Description</label>
                                    <textarea class="textarea" placeholder="Place some text here" name="description" id="description">{{ old('description') }}</textarea>
                                </div>
                            </div>
                            <!-- /.card-body -->

                            <div class="card-footer">
                                <button type="submit" class="btn btn-primary">Create</button>
                                <button type="submit" class="btn btn-danger">Cancel</button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
            <!-- /.row -->
        </div><!-- /.container-fluid -->

    </section>
    <!-- /.content -->
@endsection

@section('js')
<script src="{{ asset('admin-lte/plugins/jquery-validation/jquery.validate.min.js') }}"></script>
<script src="{{ asset('admin-lte/plugins/jquery-validation/additional-methods.min.js') }}"></script>
<script src="{{ asset('admin-lte/plugins/bs-custom-file-input/bs-custom-file-input.min.js') }}"></script>
<script src="{{ asset('admin-lte/js/global.js') }}"></script>
@endsection

resources/views/admin/services/posts/edit.blade.php
@extends('layouts.admin.app')

@section('content')
    <!-- Main content -->
    <section class="content content-section">
        <div class="container-fluid">
            <div class="row">
                <!-- left column -->
                <div class="col-md-12">
                    <!-- general form elements -->
                    <div class="card card-warning">
                        <div class="card-header">
                            <h3 class="card-title">Edit Service Posts</h3>
                        </div>
                        <!-- /.card-header -->
                        <!-- form start -->
                        {!! Form::model($servicePost, [
                            'enctype' => "multipart/form-data",
                            'method' => 'PATCH',
                            'route' => ['admin.service.posts.update', $servicePost->id]
                        ]) !!}
                            <div class="card-body">
                                @include('layouts.errors-and-messages')
                                <div class="form-group">
                                    <label for="inputName">Name</label>
                                    <input type="text" name="name" class="form-control" id="inputName" placeholder="Enter Name" value="{{ !empty($servicePost['name']) ? Request::old('name', $servicePost['name']) : '' }}">
                                </div>
                                <div class="form-group">
                                    <label for="inputSlug">Slug</label>
                                    <input type="text" name="slug" class="form-control" id="inputSlug" placeholder="Enter Slug" value="{{ !empty($servicePost['slug']) ? Request::old('slug', $servicePost['slug']) : '' }}">
                                </div>
                                <div class="form-group">
                                    <label>Services</label>
                                    <select class="form-control select2" name="service_id" style="width: 100%;">
                                        @foreach($services as $key => $service)
                                            <option value="{{ $service->id }}" @if($service->id == $servicePost->service_id) selected @endif>{{ $service->name }}</option>
                                        @endforeach
                                    </select>
                                </div>
                                <div class="form-group">
                                    <label for="exampleInputFile">Image</label>
                                    <div class="input-group">
                                        <div class="custom-file">
                                            <input type="file" name="img" class="custom-file-input" id="exampleInputFile" value="">
                                            <label class="custom-file-label" for="exampleInputFile">Choose file</label>
                                        </div>
                                        <div class="input-group-append">
                                            <span class="input-group-text" id="">Upload</span>
                                        </div>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label>Status</label>
                                    <select class="form-control select2" name="status" style="width: 100%;">
                                        <option value="1" {{ !empty($servicePost['status']) ? 'selected' : '' }}>Yes</option>
                                        <option value="0" {{ empty($servicePost['status']) ? 'selected' : '' }}>No</option>
                                    </select>
                                </div>
                                <div class="form-group">
                                    <label for="exampleDescription">Description</label>
                                    <textarea class="textarea" placeholder="Place some text here" name="description" id="description">{!! Request::old('description', $servicePost['description']) !!}</textarea>
                                </div>
                            </div>
                            <!-- /.card-body -->

                            <div class="card-footer">
                                <button type="submit" class="btn btn-primary">Edit</button>
                                <button type="submit" class="btn btn-danger">Cancel</button>
                            </div>
                        {!! Form::close() !!}
                    </div>
                </div>
            </div>
            <!-- /.row -->
        </div><!-- /.container-fluid -->

    </section>
    <!-- /.content -->
@endsection

@section('js')
    <script src="{{ asset('admin-lte/plugins/jquery-validation/jquery.validate.min.js') }}"></script>
    <script src="{{ asset('admin-lte/plugins/jquery-validation/additional-methods.min.js') }}"></script>
    <script src="{{ asset('admin-lte/plugins/bs-custom-file-input/bs-custom-file-input.min.js') }}"></script>
    <script src="{{ asset('admin-lte/js/global.js') }}"></script>
@endsection

resources/views/admin/services/posts/list.blade.php
@extends('layouts.admin.app')

@section('content')
    <!-- Main content -->
    <section class="content content-section">
        <div class="container-fluid">
            <div class="row">
                <!-- /.col -->
                <div class="col-md-12">
                    @include('layouts.errors-and-messages')
                </div>
                <div class="col-md-12">
                    <div class="card">
                        <div class="card-header">
                            <h3 class="card-title">Simple Full Width Table</h3>
                            <a href="{{ route('admin.service.posts.create') }}" class="btn btn-info float-right"><i class="fas fa-plus"></i> Add item</a>
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body p-0">
                            <table class="table">
                                <thead>
                                <tr>
                                    <th style="width: 100px">#</th>
                                    <th>Name Services</th>
                                    <th>Name</th>
                                    <th>Descriptions</th>
                                    <th style="width: 10%">Status</th>
                                    <th style="width: 18%">Action</th>
                                </tr>
                                </thead>
                                <tbody>
                                @if(count($service_posts) > 0)
                                    @foreach($service_posts as $key => $service)
                                    <tr>
                                        <td>{{ ++$i }}</td>
                                        <td>{{ $service->service->name }}</td>
                                        <td>{{ $service->name }}</td>
                                        <td>
                                            {{ !empty($service->description) ? trim_word($service->description,110) : ''  }}
                                        </td>
                                        <td>
                                            <div class="custom-control custom-switch">
                                                <input type="checkbox"
                                                       class="custom-control-input"
                                                       id="customSwitch_{{$service['id']}}"
                                                       name="check-switch"
                                                       @if(!empty($service['status'])) checked @endif
                                                       data-id="{{$service['id']}}">
                                                <label class="custom-control-label" for="customSwitch_{{$service['id']}}"></label>
                                            </div>
                                        </td>
                                        <td>
                                            <a href="{{ route('admin.service.posts.show', ['post' => $service->id]) }}"><span class="btn-left badge bg-primary">View</span></a>
                                            <a href="{{ route('admin.service.posts.edit', ['post' => $service->id]) }}"><span class="btn-left badge bg-success">Edit</span></a>
                                            {{ Form::open(['route' => ['admin.service.posts.destroy', $service->id], 'method' => 'delete']) }}
                                                <button type="submit" class="btn-left badge bg-danger" style="border: 0">Delete</button>
                                            {{ Form::close() }}
                                        </td>
                                    </tr>
                                    @endforeach
                                @else
                                    <tr>
                                        <td colspan="6" style="text-align: center">
                                            Data not found!
                                        </td>
                                    </tr>
                                @endif
                                </tbody>
                            </table>
                            {!! $service_posts->links() !!}
                        </div>
                    </div>
                    <!-- /.card -->
                </div>
                <!-- /.col -->
            </div>
        </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
@endsection

@section('js')
    <!-- Toastr -->
    <script src="{{ asset('admin-lte/plugins/toastr/toastr.min.js') }}"></script>
    <script>
        setTimeout( function () {
            $(".alert").fadeOut(2000);
        }, 2000)

        $('.custom-switch input[name="check-switch"]').on('change', function(event, state) {
            var dataID = $(this).data('id');
            var status = event.target.checked;

            $.ajax({
                url: '/admin/service/posts/changeStatus/'+dataID,
                type: "POST",
                data: {
                    "_token": "{{ csrf_token() }}",
                    id: dataID,
                    status: status ? 1 : 0
                },
                dataType: "json",
                success: function (data) {
                    if (data.status) {

                        toastr.success('Change status successfully.')
                    } else {
                        toastr.error('Change status fail.')
                    }
                },
                error: function (error) {
                    toastr.error(error)
                }
            });
        });
    </script>
@endsection

resources/views/admin/services/posts/show.blade.php
@extends('layouts.admin.app')

@section('content')
    <!-- Main content -->
    <section class="content content-section">
        <div class="container-fluid">
            <div class="row">
                <!-- left column -->
                <div class="col-md-12">
                    <!-- general form elements -->
                    <div class="card card-warning">
                        <div class="card-header">
                            <h3 class="card-title">View Service Post</h3>
                        </div>
                        <div class="card-body">
                            <div class="form-group">
                                <div class="row">
                                    <div class="col-md-2">
                                        <label>Name: </label>
                                    </div>
                                    <div class="col-md-10">
                                        <span>{{ !empty($servicePost['name']) ? $servicePost['name'] : '' }}</span>
                                    </div>
                                </div>
                            </div>
                            <div class="form-group">
                                <div class="row">
                                    <div class="col-md-2">
                                        <label>Slug: </label>
                                    </div>
                                    <div class="col-md-10">
                                        <span>{{ !empty($servicePost['slug']) ? $servicePost['slug'] : '' }}</span>
                                    </div>
                                </div>
                            </div>
                            <div class="form-group">
                                <div class="row">
                                    <div class="col-md-2">
                                        <label>Name Service: </label>
                                    </div>
                                    <div class="col-md-10">
                                        <span>{{ !empty($servicePost->service) ? $servicePost->service->name : '' }}</span>
                                    </div>
                                </div>
                            </div>
                            <div class="form-group">
                                <div class="row">
                                    <div class="col-md-2">
                                        <label>Image: </label>
                                    </div>
                                    <div class="col-md-4">
                                        <p>
                                            <img style="max-width: 100%;" src="{{ asset('storage/'.$servicePost['img']) }}">
                                        </p>
                                    </div>
                                </div>
                            </div>
                            <div class="form-group">
                                <div class="row">
                                    <div class="col-md-2">
                                        <label>Status: </label>
                                    </div>
                                    <div class="col-md-10">
                                        <span> {{ !empty($servicePost['status']) ? 'Active' : 'Unactive' }}</span>
                                    </div>
                                </div>
                            </div>
                            <div class="form-group">
                                <div class="row">
                                    <div class="col-md-2">
                                        <label>Description: </label>
                                    </div>
                                    <div class="col-md-10">
                                        <span> {!! !empty($servicePost['description']) ? $servicePost['description'] : '' !!}</span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <!-- /.card-body -->
                    </div>
                </div>
            </div>
            <!-- /.row -->
        </div><!-- /.container-fluid -->

    </section>
    <!-- /.content -->
@endsection